require "report_frontend/dependencies"
require "report_frontend/token_authentication"

module ReportFrontend
    class Engine < ::Rails::Engine
        isolate_namespace ReportFrontend

        # We need to preconfigure her for us..
        initializer "init_her" do |app|
            if not Rails.application.config.respond_to?(:web_frontend)
                puts "Missing configuration Rails.application.config.web_frontend !!"
            else
                ssl_options = Rails.application.config.web_frontend[:SSL_OPTIONS]
                Her::API.setup url: "#{Rails.application.config.web_frontend[:SERVER_URL]}/api/v1/", ssl: ssl_options do |c|
                    # Request
                    c.use TokenAuthentication
                    c.use Faraday::Request::UrlEncoded

                    # Response
                    c.use Her::Middleware::DefaultParseJSON

                    # Adapter
                    c.use Faraday::Adapter::NetHttp
                end
            end
        end
    end
end
